	;	Disassembled by:
	;		DASMx object code disassembler
	;		(c) Copyright 1996-2003   Conquest Consultants
	;		Version 1.40 (Oct 18 2003)
	;
	;	File:		dumpp61a.bin (Korg 8049 C 337 MCU)
	;	Size:		2048 bytes
	;	Checksum:	8A68
	;
	;	Date:		Tue Sep 06 20:54:43 2016
	;	CPU:		Intel 8049 (MCS-48 family)

;tasm -48 -g3 p61prog.asm p61prog.bin
; g0 is Intel Hex
; g3 selects binary

; 9/6 Initial disassembly
; 9/9 Got the code running in Aldec simulator.   Just the 8255's EPROM, RAM, and switches.

;RAM usage: (128 bytes)

rb0r0	.equ	00h
rb0r1	.equ	01h
rb0r2	.equ	02h
rb0r3	.equ	03h
rb0r4	.equ	04h
rb0r5	.equ	05h
rb0r6	.equ	06h
rb0r7	.equ	07h

rb1r0	.equ	08h
rb1r1	.equ	09h
rb1r2	.equ	0Ah
rb1r3	.equ	0Bh
rb1r4	.equ	0Ch
rb1r5	.equ	0Dh		;holds interval between DCO's, values were -3:4E(78dec),3:50(80dec),4:52(82dec)
				;values are doubled, since this is divider table offset, so -3:39,3:40,4:41
				;seems to reflect octave setting as well. -3 is minor third, 3 is major third, and 4 is perfect 4th
rb1r6	.equ	0Eh
rb1r7	.equ	0Fh

numval	.equ	024h		;when a new prog or parm # is being entered, it is assembled here
flags1	.equ	025h		;D0 set when left digit of prog or parm already entered	
				;D1 set when right digit of prog already entered
				;D2 set when we select a new parameter	
				;D4 set when write, prog, or parm sw pressed

curprog	.equ	027h		;number of current program, 
curparm	.equ	028h		;number of current parameter, in binary 11 is 0, 21 is 4, etc
parmadd	.equ	029h		;points to byte that holds current parm in temp buf (54 for res)
parmin1	.equ	02Bh		;top two bits of first table byte, has to do with how value changes
parmin2 .equ	02Ch		;upper nibble+1 of second table byte is stored here
				;this is right shift count+1 needed to right justify parm in byte
parmin3	.equ	02Dh		;F4 table value for each parm stored here
				;this is a bit mask for the parm bits, after right shifting

pbuf0	.equ	040h		;8-byte patch buffer
pbuf1	.equ	041h		;for currently selected patch
pbuf2	.equ	042h
pbuf3	.equ	043h
pbuf4	.equ	044h
pbuf5	.equ	045h
pbuf6	.equ	046h
pbuf7	.equ	047h
				;IC42 bits:
tmpbuf0	.equ	050h		;these bits are written to the hw at the same address (8255 regs)
tmpbuf1	.equ	051h		;when we change a parm, bits in this area change, not in patch buffer
tmpbuf2	.equ	052h		;cutoff in D7:2
tmpbuf3	.equ	053h		;not used, since this addr is control reg in 8255

				;IC28 bits
tmpbuf4	.equ	054h		;resonance in D3:1
tmpbuf5	.equ	055h
tmpbuf6	.equ	056h
tmpbuf7	.equ	057h		;not used, since this addr is control reg in 8255

				;IC22 bits
tmpbuf8	.equ	058h		
intval	.equ	059h		;related to value of interval parameter
				;when sel parm was #23, -3 had 1, 3 had 2, and 4 had 3 here

				;display buffer, these contain LED segment bits:
value1	.equ	05Bh		;value display LSdigit storage, D7 controls EDIT LED		
value10	.equ	05Ch		;value display MSdigit storage		
parm1	.equ	05Dh		;parameter display LSdigit storage		
parm10	.equ	05Eh		;parameter display MSdigit storage		
prog1	.equ	05Fh		;program display LSdigit storage		
prog10	.equ	060h		;program display MSdigit storage

y0swdn	.equ	063h		;row 0 sw down flags (1= sw is down)
y1swdn	.equ	064h		;row 1 sw down flags
y0flags	.equ	065h		;possibly flags for new sw presses in row Y0 (number switches)		
y1flags	.equ	066h		;possibly flags for new sw presses in row Y1		


	.org	00000H

	dis	i		;reset starts executing here
L0001:
	jmp	L0775


;L0003:				;we jump here on external interrupt
	jmp	L0137


L0005:
	movp	a,@a		;read page 0 table byte at addr in acc
	ret

L0007:				;we jump here on timer/counter interrupt
	dis	i
	jmp	L00FC


L000A:				;this seems like main code loop
	clr	a
	mov	psw,a
	mov	r0,#025H	;flags?
L000E:
	mov	a,@r0
	jb7	L0013
	jmp	L000E

L0013:
	anl	a,#07FH
	mov	@r0,a
L0016:
	call	L02DA
	call	L041B
L001A:
	mov	r0,#026H
	mov	a,@r0
L001D:
	jb0	L0036		;handle addr 26 action flags in order lsbit to msbit
	jb1	L003C
	jb2	L0042
	jb3	L0048
	jb4	L004E
	jb5	L0054
	jb6	L005A
	jb7	L0060

	in	a,p1
	jb5	L0032
	jmp	L0190

L0032:
	call	L071E
	jmp	L000A		;back to start of loop


L0036:
	call	L0522	
	mov	a,#0FEH		;mask to clear D0 bit
L003A:
	jmp	L0064


L003C:
	call	L053F	
L003E:
	mov	a,#0FDH		;mask to clear D1 bit
	jmp	L0064


L0042:			
	call	L0306		;write current prog number to display
L0044:
	mov	a,#0FBH		;mask to clear D2 bit
	jmp	L0064


L0048:			
	call	L0318		;write current parm number to display
	mov	a,#0F7H		;mask to clear D3 bit
	jmp	L0064


L004E:
	call	L0714	
L0050:
	mov	a,#0EFH		;mask to clear D4 bit
	jmp	L0064

L0054:
	call	L06F0	
	mov	a,#0DFH		;mask to clear D5 bit
	jmp	L0064

L005A:
	call	L065C	
	mov	a,#0BFH		;mask to clear D6 bit
	jmp	L0064

L0060:
	call	L0700		;update Edit LED based on current parm value in tmp buf and value in patch buf
	mov	a,#07FH		;mask to clear D7 bit
L0064:
	mov	r0,#026H
	anl	a,@r0		;clear sw flag we acted on
	mov	@r0,a		;update sw states
	jmp	L001D


;L006A:
	.db	$45
	.db	$49
	.db	$5A
	.db	$49
;L006E:
	.db	$32
	.db	$16
	.db	$08
	.db	$04
	.db	$02
	.db	$01

;L0074:				;a table of masks
	.db	$FE		;just D0 low
	.db	$FD		;just D1 low
	.db	$FB		;just D2 low
	.db	$F7		;just D3 low
	.db	$EF		;just D4 low
	.db	$DF		;just D5 low

;L007A:

SegsTab:   ;	 gfedcba	;segment patterns for 0-9
	.db	00111111b	;$3F  0
	.db	00000110b	;$06  1
	.db	01011011b	;$5B  2
	.db	01001111b	;$4F  3
	.db	01100110b	;$66  4
	.db	01101101b	;$6D  5
	.db	01111101b	;$7D  6
	.db	00000111b	;$07  7
	.db	01111111b	;$7F  8
	.db	01101111b	;$6F  9


;L0084:			;a bunch of tables of various sizes
	.db	$7D
	.db	$06
	.db	$7F
	.db	$00

;L0088:			;12-byte table
	.db	$66
	.db	$00
	.db	$08
	.db	$00
	.db	$06
	.db	$4F
	.db	$4F
	.db	$66
	.db	$6D
	.db	$08
	.db	$08
	.db	$08

;L0094:			;4-byte table
	.db	$01
	.db	$00
	.db	$02
	.db	$01

;L0098:			;20-byte table
	.db	$48
	.db	$30
	.db	$18
	.db	$30
	.db	$4E
	.db	$36
	.db	$1E
	.db	$36
	.db	$50
	.db	$38
	.db	$20
	.db	$38
	.db	$52
	.db	$3A
	.db	$22
	.db	$3A	
	.db	$56
	.db	$3E
	.db	$26
	.db	$3E

;L00AC:			;16-byte table
	.db	$0E
	.db	$0E
	.db	$0E
	.db	$0E
	.db	$0F
	.db	$07
	.db	$03
	.db	$0E
	.db	$08
	.db	$04
	.db	$02
	.db	$0E
	.db	$0E
	.db	$0E
	.db	$0E
	.db	$0E


	;top 2 bits of first byte are either 
	;01 (incrementing parm)
	;10 (octave parm)
	;11 (interval parm)

	;low nibble of first byte is index into tmp buf/hw 
	;starting at 0x50 to access this parm's bits
	;so for instance VCF cutoff has 2, which maps to 
	;RAM and hw address 0x52, which is 8255 IC42 PortC
	;3 is a special case, since there is no port at addr 53

	;upper nibble of second byte is shift count to 
	;right-justify parm in both hw and RAM buffers

;L00BC:
	.db	$A0	;11 DCO1 octave                 F4 tab   EC tab
	.db	$31	;11                un+1=4, ln=1->3         2

	.db	$53	;12 DCO1 waveform       
	.db	$41	;12                     5     1->3         2

	.db	$40	;13 DCO1 PW                  
	.db	$53	;13                     6     3->7         7

	.db	$00	;14 
	.db	$00	;14

	.db	$B3	;21 DCO2 octave              
	.db	$01	;21                     1     1->3         2

	.db	$73	;22 DCO2 waveform            
	.db	$21	;22                     3     1->3         2

	.db	$E9	;23 DCO2 interval            
	.db	$07	;23                     1     7->7         4

	.db	$40	;24 DCO2 detune               
	.db	$06	;24                     1     6->7         5

	.db	$42	;31 VCF cutoff               
	.db	$25	;31                     3     5->3F       3F

	.db	$44	;32 VCF resonance            
	.db	$13	;32                     2     3->7         7

	.db	$41	;33 VCF tracking             
	.db	$70	;33                     8     0->1         1

	.db	$41	;34 VCF EG int               
	.db	$43	;34                     5     3->7         7

	.db	$44	;41 EG attack                
	.db	$44	;41                     5     4->F         F

	.db	$45	;42 EG decay                  
	.db	$04	;42                     1     4->F         F

	.db	$45	;43 EG sustain               
	.db	$44	;43                     5     4->F         F

	.db	$46	;44 EG release               
	.db	$04	;44                     5     4->F         F

	.db	$44	;51 VCA EG mode              
	.db	$00	;51                     1     1->3         2

	.db	$00	;52 
	.db	$00	;52

	.db	$00	;53
	.db	$00	;53

	.db	$00	;54
	.db	$00	;54

	.db	$46	;61 MG freq                 
	.db	$44	;61                     7     4->F         F

	.db	$48	;62 MG delay                
	.db	$02	;62                     7     2->3         3

	.db	$48	;63 MG DCO amt              
	.db	$23	;63                     7     3->7         7

	.db	$48	;64 MG VCF amt              
	.db	$53	;64                     7     3->7         7


;L00EC:			;table related to number of values for each parm?
	.db	$01	;0
	.db	$02	;1
	.db	$03	;2
	.db	$07	;3
	.db	$0F	;4
	.db	$3F	;5
	.db	$05	;6
	.db	$04	;7


			;table of bit masks for parameters, applied after parm is right-justified
;L00F4:			;accessed using low nibble of second byte of each param in BC table
	.db	$01	;0
	.db	$03	;1
	.db	$03	;2
	.db	$07	;3
	.db	$0F	;4
	.db	$3F	;5
	.db	$07	;6
	.db	$07	;7



L00FC:				;Timer/ctr interrupt jumps here
	sel	rb1		;second register bank
	mov	r2,a		;save acc in r2		

	mov	a,#0F3H
	mov	t,a		;write 0xF3 to the timer 

	in	a,p2
	mov	r3,a		;save current port 2 value in r3

	orl	p2,#07FH	;set all port 2 bits except D7 (interrupt reset)
				;this will disable xRAM and the I/O decoder
	call	L010E		;refreshing the display

	mov	a,r3		;get port 2 value that we saved
	orl	a,#007H		;set the low 3 bits
	outl	p2,a		;and restore it (code we interrupted 
				;may have set up something in port 2)

	mov	a,r2		;restore acc from r2
	en	i
	retr



L010E:				;refreshing the display
	dec	r7		;r7 counts 5->0
	mov	a,r7
	cpl	a		;when it goes to 0xFF, this goes to 0
	jb7	L0115		;and we don't jump here
	mov	r7,#005H	;but set r7 to 5 instead
L0115:
	mov	r1,#05AH	;IC42 port C addr (com digit selects)
	anl	p2,#0BFH	;P26=0, enable IC11 decoder
	clr	a
	cpl	a
	movx	@r1,a		;disable all coms first

	xch	a,r1		;incr r1 value to 0x5B and add r7 to it
	inc	a		;so r1 counts down from 0x60 to 0x5B (which is the display buffer)
	add	a,r7
	xch	a,r1

	mov	a,@r1		;read from r1 addr in RAM (display data)
	mov	r1,#059H	;IC42 port B addr (seg data outputs)
	movx	@r1,a

	mov	r1,#05AH	;IC42 port C addr (com digit selects)
	mov	a,r7
	jb2	L012B
	jmp	L012F

L012B:				;if r7 is 4 or 5
	mov	a,r6
	jb7	L0134		;if bit 7 of r6 set, leave coms disabled (maybe for flashing the prog display)
	mov	a,r7		;otherwise, enable correct com for this data
L012F:
	add	a,#074H		;table of masks, 1 bit low, D0, then D1, etc
	call	L0005		;read page 0 table byte at addr in acc
	movx	@r1,a
L0134:
	orl	p2,#040H	;P26=1, disable IC11 decoder
	ret			;and Bob's your uncle!



				;ext interrupt jumps here
L0137:				;we read 3 bits from the other MCU
				;for 6 of the 8 cases, we then read a note number
				;and use it to program the DCO divider from the table			
	sel	rb1		;switch to reg bank 1	
	mov	r2,a		;save acc in r2

	in	a,p2
	mov	r3,a		;save p2 state in r3

	anl	a,#007H
	mov	r0,a
	orl	p2,#0FFH

	add	a,#043H
	jmpp	@a		;INFO: indirect jump

L0143:				;same page jump table (just low 8 bits)
	.db	$4B		;0 probably voice 1 key assigner S&H update
	.db	$4B		;1
	.db	$4B		;2
	.db	$4F		;3
	.db	$4F		;4
	.db	$4F		;5
	.db	$7D		;6
	.db	$8C		;7

;L014B:
	mov	a,#020H		;selects 8253 IC4
	jmp	L0151

;L014F:
	mov	a,#021H		;selects 8253 IC13
L0151:
	add	a,r0
	mov	r0,a		;r0 pts to DCO1 for this voice?
	add	a,#008H
	mov	r1,a		;r1 pts to DCO2 for this voice?

	anl	p2,#07FH	;enable data buffer between two data buses
	ins	a,bus		;read other MCU's data bus to get note info
	orl	p2,#0FFH	;disable data buffer
	clr	c
	rlc	a		;shift note info left 1, since table is words
	add	a,#031H		;then add 0x31 to it (offset of lsbyte of first table entry)
	mov	r4,a
	anl	p2,#0BFH	;drop P26 to enable IC11 I/O decoder
	movp3	a,@a		;read LSbyte from divider table
	movx	@r0,a		;send it to DCO1 8253
	mov	a,r4
	dec	a
	movp3	a,@a		;read MSbyte from divider table
	movx	@r0,a		;send it to DCO1 8253
	mov	a,r4
	add	a,r5		;r5 related to interval between DCO's?
	jnc	L0170
L016C:
	add	a,#0E8H		;add -24dec, or one octave, in case of overflow
	jc	L016C
L0170:
	mov	r4,a
	movp3	a,@a		;read LSbyte from divider table
	movx	@r1,a		;send it to DCO2 8253
	mov	a,r4
	dec	a
	movp3	a,@a		;read MSbyte from divider table
	movx	@r1,a		;send it to DCO2 8253
L0177:
	mov	a,r3
	orl	a,#007H
	outl	p2,a		;restore saved p2 from r3, with low 3 bits set
	mov	a,r2		;restore saved acc from r2
	retr			;return with PSW restore


;L017D:				;in jump table at 143 for code 6
	inc	r6
	mov	a,r6
	jb1	L0183
	jmp	L018C

L0183:
	anl	a,#080H
	mov	r6,a

	mov	r0,#025H	;set bit 7 at RAM addr 0x25
	mov	a,#080H
	orl	a,@r0
	mov	@r0,a

L018C:				;in jump table at 143 for code 7
	anl	p2,#07FH	;reset interrupt ff
	jmp	L0177



L0190:				;looks like tape code
	dis	tcnti
	dis	i
	anl	p1,#000H
L0194:
	mov	a,#0E4H		;point to "TAPE" message
	call	L07D3		;displays 4 chars at pg7 addr in acc

	clr	a
	mov	psw,a
L019A:
	mov	r0,#064H
	clr	c
	nop
	clr	f0
	call	L0282
	cpl	a
	jb0	L01AA
	jb2	L01D5
	jb1	L01AC
	jmp	L019A
L01AA:
	jmp	L02AC

L01AC:
	cpl	f0
	call	L021E

	mov	a,#0F0H		;point to "LOAD"
	call	L07D3		;displays 4 chars at pg7 addr in acc

	call	L029F
	call	L0400
	jmp	L01BB

L01B9:
	orl	p1,#002H	;set P11 (xRAM A9)
L01BB:
	mov	r6,#000H
	mov	r1,#000H
L01BF:
	call	L01FC
	xch	a,r4
	add	a,r4
	xch	a,r4
	call	L0592		;writes acc to xRAM addr r1, incs r1
	djnz	r6,L01BF
	djnz	r5,L01B9
L01CA:
	call	L01FC
	xrl	a,r4
	jnz	L01F6

	mov	a,#0FCH		;point to "Good" message
	call	L07D3		;displays 4 chars at pg7 addr in acc

	jmp	L019A

L01D5:
	mov	a,#0F4H		;point to "vrFY" message
	call	L07D3		;displays 4 chars at pg7 addr in acc

	call	L029F
	call	L0400
	jmp	L01E1

L01DF:
	orl	p1,#002H	;set P11 (xRAM A9)
L01E1:
	mov	r6,#000H
	mov	r1,#000H
L01E5:
	call	L01FC
	xch	a,r4
	add	a,r4
	xch	a,r4
	mov	r3,a
	call	L057F		;reads xRAM byte at addr r1 into acc, incs r1
	xrl	a,r3		;compare with r3 value
	jnz	L01F6		;err if mismatch

	djnz	r6,L01E5
	djnz	r5,L01DF
	jmp	L01CA

L01F6:
	mov	a,#0F8H		;pt to "Err " message
	call	L07D3		;displays 4 chars at pg7 addr in acc

	jmp	L019A

L01FC:
	call	L0250
	jc	L01FC
	mov	r7,#008H
L0202:
	call	L0250
	xch	a,r3
	rrc	a
	xch	a,r3
	djnz	r7,L0202
	mov	a,r3
	ret



L020B:
	clr	c
	cpl	c
	mov	r7,#000H
L020F:
	call	L0282
	djnz	r7,L020F
L0213:
	djnz	r6,L020F
	ret



L0216:				;probably tape code
	sel	rb1
	rrc	a
	mov	r2,a
	call	L010E
	mov	a,r2
	rlc	a
	sel	rb0
L021E:
	jf0	L0222
	jmp	L022D

L0222:
	anl	p2,#0BFH	;P26 low to enable IC11 I/O decoder
	movx	a,@r0
	orl	p2,#040H	;P26 high to disable IC11 I/O decoder
	jb6	L022B
	jmp	L022D
L022B:
	jmp	L0194

L022D:
	anl	p2,#0BFH	;P26=0, enable IC11 I/O decoder
	movx	a,@r0
	jb5	L023C
	dec	r0
	movx	a,@r0
	orl	p2,#040H	;P26 high to disable IC11 I/O decoder
	inc	r0
	jb3	L023B
	jmp	L0194
L023B:
	ret



L023C:
	orl	p2,#0FFH

	mov	a,#024H		;set P12 and P15 bits (Program mode)
	outl	p1,a

	mov	r1,#026H
	mov	@r1,#0CDH
L0245:
	anl	p2,#07FH	;clear interrupt ff if it's set
	orl	p2,#0FFH
	clr	a
	mov	psw,a
	strt	t
	en	tcnti
	en	i
	jmp	L001A		;jump to main loop



L0250:				;seems like tape code
	clr	c
	mov	r2,#050H
	jf1	L025B
L0255:
	jt1	L0264
	djnz	r2,L0255	;loop

	jmp	L025F

L025B:
	jnt1	L0264
	djnz	r2,L025B
L025F:
	mov	r5,#001H
	mov	r6,#001H
	cpl	f1
L0264:
	cpl	f1
	jtf	L0268
	cpl	c
L0268:
	mov	a,#0FAH
	mov	t,a
	call	L0216
	ret



L026E:
	mov	r3,a
	clr	c
	call	L0282
	mov	r7,#008H
L0274:
	mov	a,r3
	rrc	a
	mov	r3,a
	call	L0282
	djnz	r7,L0274
	clr	c
	cpl	c
	call	L0282
	call	L0282
	ret



L0282:
	in	a,p1
	jb6	L0289
	orl	a,#0C0H
	jmp	L028B

L0289:
	anl	a,#03FH
L028B:
	mov	r2,a
	mov	a,#0FCH
	jc	L0295
	rlc	a
	xch	a,r2
	xrl	a,#080H
	xch	a,r2
L0295:
	jtf	L0299
	jmp	L0295

L0299:
	mov	t,a
	mov	a,r2
	outl	p1,a
	call	L0216
	ret



L029F:
	call	L01FC
	xrl	a,#050H
	jnz	L029F
	call	L01FC
	xrl	a,#036H
	jnz	L029F
	ret



L02AC:
	mov	a,#0ECH		;point to "SAVE" message
	call	L07D3		;displays 4 chars at pg7 addr in acc

	mov	r6,#028H
	call	L020B
	mov	a,#050H
	call	L026E
	mov	a,#036H
	call	L026E
	call	L0400
	jmp	L02C2

L02C0:
	orl	p1,#002H	;set P11 (xRAM A9)
L02C2:
	mov	r6,#000H
	mov	r1,#000H
L02C6:
	call	L057F		;reads xRAM byte at addr r1 into acc, incs r1
	xch	a,r4
	add	a,r4
	xch	a,r4
	call	L026E
	djnz	r6,L02C6
	djnz	r5,L02C0
	mov	a,r4
	call	L026E
	mov	r6,#006H
	call	L020B
	jmp	L0190



L02DA:				;looks like code to read the switches
	mov	r0,#063H
	anl	p2,#0BFH	;P26=0, enable IC11 I/O decoder
	movx	a,@r0		;Y0 active
	cpl	a		;invert bits we just read
	xch	a,@r0		;swap with RAM 63, so RAM holds 1 for pressed sw
	cpl	a		;invert RAM value
	anl	a,@r0		;AND RAM with inverted new bits
				;this should leave bits that are now low,
				;and were 0 in RAM var
	inc	r0		;r0=0x64
	inc	r0		;r0=0x65
	mov	@r0,a		;save Y0 new press flags in RAM at 65?

	dec	r0		;r0=0x64 (Y1)
	movx	a,@r0
	orl	p2,#040H	;P26 high to disable IC11 I/O decoder
	cpl	a		;invert bits we just read
	mov	r2,a		;save in r2

	xch	a,@r0		;swap with RAM 64, so RAM holds 1 for pressed sw
	cpl	a		;invert RAM value
	anl	a,@r0		;AND RAM with inverted new bits
				;this should leave bits that are now low,
				;and were 0 in RAM var
	xch	a,r2		;put new press flags in r2
	rr	a		;rotate inverted data we just read right
	rr	a		;twice
	orl	a,#0EFH		;set all bits except D4
	anl	a,r2
	inc	r0		;r0=0x65
	inc	r0		;r0=0x66
	mov	@r0,a		;save Y1 new press flags in RAM at 66?		
	anl	a,#01CH		;check for write, param, or prog switches?
	jnz	L02FD
	ret



L02FD:
	mov	r0,#025H
	mov	a,#010H
	dis	i
	orl	a,@r0		;set bit 4 in RAM 0x25 byte
	mov	@r0,a
	en	i
L0305:
	ret



L0306:				;write current prog number to display buffer
	mov	r0,#027H	;current program number in binary?
	mov	r1,#05FH	;program LSdigit in display buffer
	mov	a,@r0
	anl	a,#007H
L030D:
	add	a,#07BH		;7B is addr of segs table starting with "1"
	call	L0005		;read page 0 table byte at addr in acc
	mov	@r1,a
	inc	r1
	mov	a,@r0
	rl	a
	swap	a
	jmp	L0328

L0318:				;write current parm number to display buffer
	mov	r0,#028H	;current parameter number in binary?
	mov	r1,#05DH	;parameter LSdigit in display buffer
	mov	a,@r0
	anl	a,#003H
	add	a,#07BH		;7B is addr of segs table starting with "1"
	call	L0005		;read page 0 table byte at addr in acc
	mov	@r1,a
	inc	r1
	mov	a,@r0
	rr	a
L0327:
	rr	a
L0328:
	anl	a,#007H
	add	a,#07BH		;7B is addr of segs table starting with "1"
	call	L0005		;read page 0 table byte at addr in acc
	mov	@r1,a		;update MSdigit in display buffer
L032F:
	ret



L0330:				;possibly the divider values for our notes
	.db	$E1,$70
	.db	$D4,$C2
	.db	$C8,$D0
	.db	$BD,$8C
	.db	$B2,$E9
	.db	$A8,$E5
	.db	$9F,$6A
	.db	$96,$78
	.db	$8E,$06
	.db	$86,$0D
	.db	$7E,$87
	.db	$77,$6D
	.db	$70,$8A
	.db	$6A,$37
	.db	$64,$41
	.db	$5E,$A3
	.db	$59,$54
	.db	$54,$53
	.db	$4F,$96
	.db	$4B,$22
	.db	$46,$E8
	.db	$42,$EE
	.db	$3F,$2E
	.db	$3B,$A5
	.db	$38,$59
	.db	$35,$2C
	.db	$32,$2F
	.db	$2F,$62
	.db	$2C,$B9
	.db	$2A,$36
	.db	$27,$D5
	.db	$25,$9B
	.db	$23,$7D
	.db	$21,$7F
	.db	$1F,$9F
	.db	$1D,$D9
	.db	$1C,$27
	.db	$1A,$91
	.db	$19,$13
	.db	$17,$AB
	.db	$16,$57
	.db	$15,$17
	.db	$13,$E7
	.db	$12,$CB
	.db	$11,$BB
	.db	$10,$BE
	.db	$0F,$CD
	.db	$0E,$EB
	.db	$0E,$15
	.db	$0D,$4A
	.db	$0C,$8B
	.db	$0B,$D7
	.db	$0B,$2D
	.db	$0A,$8D
	.db	$09,$F5
	.db	$09,$65
	.db	$08,$DF
	.db	$08,$5D
	.db	$07,$E7
	.db	$07,$75
	.db	$07,$09
	.db	$06,$A3
	.db	$06,$45
	.db	$05,$EB
	.db	$05,$97
	.db	$05,$47
	.db	$04,$F9
	.db	$04,$B3
	.db	$04,$6F
	.db	$04,$2F
	.db	$03,$F3
	.db	$03,$BB
	.db	$03,$85
	.db	$03,$53
	.db	$03,$23
	.db	$02,$F5
	.db	$02,$CB
	.db	$02,$A3
	.db	$02,$7D
	.db	$02,$59
	.db	$02,$37
	.db	$02,$17
	.db	$01,$F9
	.db	$01,$DD
	.db	$01,$C3
	.db	$01,$A9
	.db	$01,$91
	.db	$01,$7B
	.db	$01,$65
	.db	$01,$51
	.db	$01,$3F
	.db	$01,$2D
	.db	$01,$1C
	.db	$01,$0C
	.db	$00,$FD
	.db	$00,$EF
	.db	$00,$E1
	.db	$00,$D5
	.db	$00,$C9
	.db	$00,$BD
	.db	$00,$B3
	.db	$00,$A9
	.db	$00,$9F
	.db	$00,$96

L0400:
	.db	$BC
	.db	$00

	mov	r5,#002H
	anl	p1,#0FDH	;P11 low (xRAM A9)
	ret


L0407:
	mov	r1,#020H
	mov	a,#007H
	add	a,@r1
	mov	@r1,a
	rl	a
	anl	a,@r1
	anl	a,#080H
L0411:
	sel	rb1
	dis	i
	xch	a,r6
	anl	a,#07FH
	orl	a,r6
	mov	r6,a
	en	i
	sel	rb0
	ret



L041B:
	mov	r0,#064H
	mov	a,@r0
	jb5	L0422
	jmp	L0426

L0422:
	anl	p1,#0DFH
	jmp	L044A

L0426:
	in	a,p1
	jb4	L042B		;jump if Write LED is on
	jmp	L044F

L042B:
	mov	r0,#025H
	mov	a,@r0
	jb4	L048E
	mov	r1,#064H
	mov	a,@r1
	jb6	L0437
	jmp	L048E

L0437:
	call	L0407
	call	L059F
	mov	r0,#025H
	mov	a,@r0
	jb1	L0441
	ret



L0441:
	anl	p1,#0E3H	;clear P14, P13, P12 bits
	orl	p1,#004H	;set P12 (Program mode)
	mov	a,#086H
L0447:
	inc	r0
	orl	a,@r0
	mov	@r0,a
L044A:
	clr	a
	call	L0411
	jmp	L04F3

L044F:
	mov	r0,#025H
	mov	a,@r0
	jb2	L0456
	jmp	L048A

L0456:
	mov	r1,#064H
	mov	a,@r1
	anl	a,#003H
	add	a,#05EH
	jmpp	@a		;INFO: indirect jump

;L045E:				;same page jump table (just low byte)
	.db	$62
	.db	$74
	.db	$66
	.db	$82

;L0462:
	mov	a,#0FBH
	jmp	L04F7


;L0466:
	call	L050F
	mov	a,@r0
	jb3	L046C
	ret


L046C:
	mov	a,#0F7H
	call	L04F7
	mov	a,#0D0H
	jmp	L04F0


;L0474:
	call	L050F
	mov	a,@r0
	jb3	L047A
	ret


L047A:
	mov	a,#0F7H
	call	L04F7
	mov	a,#0E0H
	jmp	L04F0

	call	L06AA
	call	L06BC
	mov	a,#0C0H
	jmp	L04C3


L048A:				;acc holds 0x25 addr contents and bit 2 is 0
	jb4	L048E
	jmp	L04AF

L048E:				;bit 4 at addr 0x25 is set (prog, parm or write sw was pressed)
	mov	r1,#066H	;probably Y1 row new sw press flags
	mov	a,@r1
	anl	p1,#0E3H	;shut off PROG, PARM, and WRITE LED's
	jb2	L0499		;bit 2 is program switch
	jb3	L049D		;bit 3 is parameter switch
	jb4	L04A1		;bit 4 is write switch
L0499:
	orl	p1,#004H	;set P12 (Program mode)
	jmp	L04A7

L049D:
	orl	p1,#008H	;set P13 (Parameter mode)
	jmp	L04A7

L04A1:
	orl	p1,#010H	;set P14 (Write mode)
	mov	r1,#020H
	mov	@r1,#000H
L04A7:
	mov	a,#0ECH
	call	L04F7
	mov	a,#00CH
	jmp	L0447


L04AF:				;acc holds 0x25 addr contents and bits 2 and 4 are both 0
	mov	r1,#066H	;probably Y1 row new sw press flags
	jb0	L04D4
	mov	a,@r1
	anl	a,#003H		;check for dn or up switch press
	add	a,#0B9H
	jmpp	@a		;INFO: indirect jump


;L04B9:				;same page jump table (just low byte)
	.db	$D4		;0 neither switch pressed
	.db	$BD		;1 up sw pressed
	.db	$C1		;2 dn sw pressed
	.db	$C8		;3 both switches pressed

L04BD:				;up sw pressed
	mov	a,#0E0H		;set bits 7,6,5 at addr 0x26
	jmp	L04C3

;L04C1:
	mov	a,#0D0H		;dn sw pressed set bits 7,6,4 at addr 0x26
L04C3:
	mov	r0,#026H
	orl	a,@r0
	mov	@r0,a

	dec	r0		;r0 = 0x25

L04C8:				;both switches pressed, or fall through
	mov	a,#004H
	dis	i
	orl	a,@r0		;set bit 2 at addr 0x25
	mov	@r0,a
	en	i
	mov	r1,#021H
	mov	@r1,#020H	;and write 0x20 to addr 0x21
	jmp	L04F3


L04D4:				;neither sw pressed
	mov	a,@r1
	jb7	L04FC

	in	a,p1
	jb3	L04E6		;if Parameter LED is on, jump

	call	L059F
	mov	r0,#025H
	mov	a,@r0
	jb1	L04E2
	ret



L04E2:
	mov	a,#0CDH
	jmp	L04F0


L04E6:				;Parameter LED is on
	call	L05D5
	mov	r0,#025H
	mov	a,@r0
	jb1	L04EE
	ret



L04EE:
	mov	a,#0C8H
L04F0:
	inc	r0
	orl	a,@r0
	mov	@r0,a
L04F3:
	mov	a,#0FCH
	mov	r0,#025H
L04F7:
	dis	i
	anl	a,@r0
	mov	@r0,a
	en	i
	ret



L04FC:				;bump current program number
	mov	r0,#027H	;pt to current program number
	mov	a,@r0		;get it
	inc	a		;bump it

;L0500:
	jt0	L0508		;t0 pin is tied high!
	anl	a,#007H
	call	L05CC
	jmp	L050B

L0508:
	anl	a,#03FH		;limit it to 63 dec
	mov	@r0,a		;update it
L050B:
	mov	r0,#025H
	jmp	L04E2

L050F:
	mov	r1,#021H
	mov	a,@r1
	dec	a
	jz	L0517
	mov	@r1,a
	ret



L0517:
	mov	@r1,#006H
	mov	r1,#025H
	mov	a,#008H
	dis	i
	orl	a,@r1
	mov	@r1,a
	en	i
	ret



L0522:				;called when Up sw is pressed
	call	L056A		;set up prog xRAM addr in r1, r0=0x40, r7=8
L0524:
	call	L057F		;reads xRAM byte at addr r1 into acc, incs r1
	mov	@r0,a
	inc	r0
	djnz	r7,L0524	;loop

	mov	@r0,a
	inc	r0
	mov	r1,#041H
	mov	a,#007H
	anl	a,@r1
	mov	@r0,a

	mov	r0,#040H	;copy ten RAM bytes from
	mov	r1,#050H	;0x40 to 0x50
	mov	r7,#00AH
L0538:
	mov	a,@r0
	mov	@r1,a
	inc	r0
	inc	r1
	djnz	r7,L0538	;loop

	ret



L053F:				;called when Dn sw is pressed
	mov	r0,#059H
	mov	r1,#051H
	mov	a,#007H
	anl	a,@r0
	xch	a,@r1
	anl	a,#0F0H
	orl	a,@r1
	mov	@r1,a
	dec	r0
	mov	a,@r0
	dec	r0
	mov	@r0,a

	mov	r0,#050H	;copy ten RAM bytes from 
	mov	r1,#040H	;0x50 to 0x40
	mov	r7,#00AH
L0555:
	mov	a,@r0
	mov	@r1,a
	inc	r0
	inc	r1
	djnz	r7,L0555	;loop

	mov	r0,#043H
	mov	a,#03FH
	anl	a,@r0
	mov	@r0,a
	call	L056A		;set up prog xRAM addr in r1, r0=0x40, r7=8
L0563:
	mov	a,@r0		;read from patch buffer
	call	L0592		;writes acc to xRAM addr r1, incs r1
	inc	r0
	djnz	r7,L0563
	ret



L056A:				;set up prog xRAM addr in r1, r0=0x40, r7=8
	mov	r0,#027H	;addr of prog number?
	mov	a,@r0
	jb5	L0573		;32-63?
				;if 32 progs occupy 512 nibbles (256 bytes)
				;then each one gets 8 bytes (64 bits)
	anl	p1,#0FDH	;clear P11 (xRAM A9)
	jmp	L0575

L0573:
	orl	p1,#002H	;set P11 (xRAM A9)
L0575:
	rr	a
	swap	a
	anl	a,#0F8H
	mov	r1,a		;start addr of prog in xRAM
	mov	r0,#040H	;dest addr in RAM?
	mov	r7,#008H	;8 bytes per prog
	ret


				;reads xRAM byte at addr r1 into acc, incs r1
L057F:				
	anl	p2,#0DFH	;P25=0 to enable xRAM chip
	anl	p1,#0FEH	;P10=0, A0 to xRAM is 0
	movx	a,@r1		;read 4 bits from xRAM
	anl	a,#00FH
	mov	r2,a		;save in r2
	orl	p1,#001H	;P10=1, A0 to xRAM is 1
	movx	a,@r1		;read 4 bits from xRAM
	orl	p2,#020H	;P25=1 to disable xRAM chip
	swap	a		;put second nibble in D7-D4
	anl	a,#0F0H
	orl	a,r2		;OR it with first one to maks a byte
	inc	r1		;bump xRAM ptr
	ret



L0592:				;writes acc to xRAM addr r1, incs r1
	anl	p2,#0DFH	;P25=0 to enable xRAM chip
	anl	p1,#0FEH	;P10=0, A0 to xRAM is 0
	movx	@r1,a		;write low 4 bits to xRAM
	swap	a
	orl	p1,#001H	;P10=1, A0 to xRAM is 1
	movx	@r1,a		;write upper 4 bits to xRAM
	orl	p2,#020H	;P25=1 to disable xRAM chip
	inc	r1		;bump xRAM ptr
	ret



L059F:
	mov	r1,#065H	;possibly flags for new keys pressed in Y0 (number keys)
	mov	a,@r1
	jz	L05D4		;if no new keys, just return

	call	L064F		;index of rightmost 1 bit in acc is returned in r2, acc

	mov	r0,#025H
	mov	a,@r0
	jb0	L05C2		;jump if bit 0 of 25 (flags) is set (left digit already entered)

	mov	a,#001H
	dis	i
	orl	a,@r0
	mov	@r0,a		;set bit 0 at addr 0x25
	en	i

	dec	r0		;r0=0x24
	mov	a,r2		;get bit index
	swap	a
	rr	a		;times 8
	mov	@r0,a		;store that at 0x24

	mov	a,r2
	add	a,#07BH		;7B is addr of segs table starting with "1"
	call	L0005		;read page 0 table byte at addr in acc
	mov	r0,#060H	;60 is addr of program MSdig in display buffer
L05BD:
	mov	@r0,a		;update it
	dec	r0
	mov	@r0,#040H	;put a dash in LSdigit
	ret



L05C2:
	mov	a,#002H
	dis	i
	orl	a,@r0		;set bit 1 at addr 0x25
	anl	a,#0FEH		;and clear bit 0
	mov	@r0,a

	en	i
	dec	r0		;r0=0x24
	mov	a,r2
L05CC:
	xch	a,@r0		;get 0x24 value into acc 
	anl	a,#038H		;keep prev # times 8 part
	orl	a,@r0		;OR in new number value
	mov	@r0,a		;update 0x24

	mov	r0,#027H
	mov	@r0,a		;set current program to this value
L05D4:
	ret



L05D5:				;parameter LED is on for us to be here
	mov	r1,#065H	;any number keys newly pressed?
	mov	a,@r1
	jnz	L05DB		;yes, so jump
	ret



L05DB:
	call	L064F		;index of rightmost 1 bit in acc is returned in r2, acc

	mov	r0,#025H
	mov	a,@r0
	jb0	L05FC		;jump if bit 0 of 25 (flags) is set (left digit already entered)

	mov	a,r2		;we are entering left digit now
	add	a,#0FAH
	jnc	L05E8		;jump if index is 0-5 (indicating digit was 1-6)
	ret



L05E8:
	mov	a,#001H
	dis	i
	orl	a,@r0
	mov	@r0,a		;set bit 0 at addr 0x25
	en	i

	mov	a,r2		;multiply 0-5 bit pos times 4 to get parm upper bits
	rl	a
	rl	a
	dec	r0		;r0=0x24
	mov	@r0,a		;build parm number in binary at addr 0x24
	mov	a,r2
	add	a,#07BH		;7B is addr of segs table starting with "1"
	call	L0005		;read page 0 table byte at addr in acc
	mov	r0,#05EH	;5E is address of parm MSdigit in display buffer
	jmp	L05BD		;put a dash in LSDigit, then return

L05FC:
	mov	a,r2
	anl	a,#0FCH		;limit second parm digit sw index to 0-3 (#1-4)
;L05FF:
	jnz	L064E		;if over, ignore it
	dec	r0		;r0=0x24
	mov	a,@r0		;get partially formed parm # in binary
	anl	a,#01CH		;keep part from MSDigit
	orl	a,r2		;add in new part
L0606:
	mov	@r0,a		;update 0x24 value
	rl	a		;rotate left to form word table index
	mov	r3,a
	add	a,#0BCH
	call	L0005		;read page 0 table byte at addr in acc
	mov	r4,a
	jb7	L0613		;if bit 6 or 7 of table byte is set, jump
	jb6	L0613
	ret			;otherwise return


	
L0613:
	mov	r0,#029H
	anl	a,#00FH		;low nibble of table byte we just read
	add	a,#050H		;added to 0x50
	mov	@r0,a		;29 holds addr (50-59) in tmp buf/hw for this parm's bits

	inc	r0		;r0=2A
	inc	r0		;r0=2B
	mov	a,r4		;get byte read from first table
	rl	a
	rl	a
	anl	a,#003H
	mov	@r0,a		;save top two bits at 0x2B
 
	inc	r0		;r0=0x2C

	mov	a,r3
	add	a,#0BDH		;table addr+1
	call	L0005		;read page 0 table byte at addr in acc
	mov	r4,a		;save table second byte
	swap	a
	anl	a,#00FH
	inc	a		;save upper nibble+1 at 0x2C addr
	mov	@r0,a

	inc	r0		;r0=0x2D

	mov	a,r4		;get back table second byte
	anl	a,#00FH
	mov	r4,a		;just keep low nibble
	add	a,#0F4H		;use it to index second table
	call	L0005		;read page 0 table byte at addr in acc
	mov	@r0,a		;save second table byte at 0x2D

	inc	r0		;r0=0x2E

	mov	a,r4		;use low nibble again to access third table
	add	a,#0ECH
	call	L0005		;read page 0 table byte at addr in acc
	mov	@r0,a		;save third table byte at 0x2E

	mov	r0,#028H	;pt to current parameter number
	mov	a,r3
	rr	a
	mov	@r0,a		;update it

	mov	r0,#025H
	mov	a,#002H
	dis	i
	orl	a,@r0		;set bit 2 at addr 0x25
	anl	a,#0FEH		;and clear bit 0
	mov	@r0,a
	en	i
L064E:
	ret


	
L064F:				;index of rightmost 1 bit in acc is returned in r2,acc
	clr	c
	mov	r2,#000H
	mov	r7,#008H
L0654:
	rrc	a
	jc	L065A
	inc	r2
	djnz	r7,L0654	;loop
L065A:
	mov	a,r2
	ret


	
L065C:
	call	L06AE
	mov	r2,a
	mov	r1,#028H
	mov	a,#001H
	xrl	a,@r1
	jz	L066A
	xrl	a,#006H
	jnz	L066B
L066A:
	inc	r2
L066B:
	mov	r1,#05BH	;5B may be addr of parm value LSDigit in display buffer 
	mov	r0,#02BH
	mov	a,@r0
	add	a,#072H
	jmpp	@a		;INFO: indirect jump

;L0673:
	.db	$76	;1
	.db	$8A	;2
	.db	$99	;3
	.db	$FA	;4
	.db	$D4	;5
	.db	$DA	;6
	.db	$53	;7
	.db	$0F	;8
	.db	$D4	;9
	.db	$84	;10
	.db	$19	;11
	.db	$FA	;12
	.db	$47	;13
	.db	$53	;14
	.db	$0F	;15
	.db	$C6	;16
	.db	$88	;17



L0684:				;write segs for value in acc to @r1
	add	a,#07AH		;7A is addr of segs table starting with "0"
L0686:
	call	L0005		;read page 0 ROM byte at addr in acc
L0688:
	mov	@r1,a		;send out data to display
	ret


	
L068A:
	mov	a,r2
	rl	a
	mov	r2,a
	add	a,#084H
	call	L0005		;read page 0 ROM byte at addr in acc
	mov	@r1,a
	inc	r1
	mov	a,r2
	inc	a
	add	a,#084H
	jmp	L0686

	mov	a,r2
	add	a,#08CH
	call	L0005		;read page 0 ROM byte at addr in acc
	mov	@r1,a
	inc	r1
	mov	a,r2
	dec	a
	jz	L06A7
	mov	@r1,#000H
	ret
	
L06A7:
	mov	@r1,#040H	;write a dash to LSDigit of parm
	ret


	
L06AA:
	mov	a,#0F0H		;call this addr to calc value of parm in patch buffer, starting at 0x40
	jmp	L06AF


L06AE:				;call this addr to calc value of parm in temp buf (current value)
	clr	a
L06AF:
	mov	r0,#029H	;29 points to byte that holds current parm in temp buf (54 for res)
	add	a,@r0
	call	L06D3		;save acc in r1, set up rotate count from 2C in r7
	mov	a,@r1
	jmp	L06B8		;skip rotate instr, so shift count is 1 more than number of rotates
				;(in case we don't need to rotate at all, then we use 1 as the count)
L06B7:
	rr	a
L06B8:
	djnz	r7,L06B7	;rotate acc right r7 value times

	anl	a,@r0		;then apply mask at address 2D
	ret

	

L06BC:
	mov	r2,a
L06BD:
	call	L06D0
	mov	a,@r0
	anl	a,r2
	mov	r2,a
L06C2:
	mov	a,@r0
	cpl	a
	jmp	L06CA

L06C6:
	rl	a
	xch	a,r2
	rl	a
	xch	a,r2
L06CA:
	djnz	r7,L06C6
	anl	a,@r1
	orl	a,r2
	mov	@r1,a
	ret


	
L06D0:
	mov	r0,#029H
	mov	a,@r0
L06D3:
	mov	r1,a		;save acc in r1

	mov	r0,#02CH
	mov	a,@r0
	mov	r7,a		;get right shift count into r7, from 2C

	inc	r0		;point to 2D next
	ret


	
L06DA:
	mov	r2,#000H
	mov	r3,a
	mov	r7,#006H
L06DF:
	mov	a,r3
	rrc	a
	mov	r3,a
	jnc	L06EC
	mov	a,r7
	add	a,#06DH
	call	L0005		;read page 0 ROM byte at addr in acc
	add	a,r2
	da	a
	mov	r2,a
L06EC:
	djnz	r7,L06DF
	mov	a,r2
	ret


	
L06F0:
	call	L06AE
	inc	r0
	inc	a
	mov	r2,a
	mov	a,@r0
	cpl	a
	add	a,r2
	jb7	L06FD
	mov	a,@r0
	jmp	L06FE

L06FD:
	mov	a,r2
L06FE:
	jmp	L06BC



L0700:				;update Edit LED based on current parm value in tmp buf and value in patch buf
	call	L06AE		;gets current value of parm in temp buffer at 0x50
	mov	r2,a
	call	L06AA		;gets value of parm in patch buffer at 0x40
	xrl	a,r2		;compare them

	mov	r0,#05BH	;point to value LSDigit in display buffer
	jz	L070F
	mov	a,#080H		;if value has changed, turn on Edit LED
	orl	a,@r0
	jmp	L0712

L070F:
	mov	a,#07FH		;otherwise value matches, turn off Edit LED
	anl	a,@r0
L0712:
	mov	@r0,a
	ret


	
L0714:				;Write sw pressed?
	call	L06AE
	dec	a
	jb7	L071B
	jmp	L071C

L071B:
	clr	a
L071C:
	jmp	L06BC


L071E:
	mov	r0,#053H
	mov	r1,#051H
	clr	f0
	mov	a,@r0
	anl	a,#00CH
	jz	L0729
	cpl	f0		;set f0 if @r0 is 12-15 dec
L0729:
	mov	a,@r0
	anl	a,#00FH
	add	a,#0ACH
	call	L0005		;read page 0 ROM byte at addr in acc

	xch	a,@r1		;put table low 4 bits in addr51 low 4
	anl	a,#0F0H		;all 	
	orl	a,@r1	
	xch	a,@r1	

	inc	r1
	mov	a,@r0
	swap	a
	anl	a,#003H
	add	a,#094H
	call	L0005		;read page 0 ROM byte at addr in acc

	xch	a,@r1
	anl	a,#0FCH
	orl	a,@r1
	xch	a,@r1

	mov	r0,#059H
	mov	r1,#050H
	mov	a,@r1
	rr	a
	swap	a
	anl	a,#0C0H
	orl	a,@r0
	rl	a
	rl	a
	add	a,#098H
	call	L0005		;read page 0 ROM byte at addr in acc

	sel	rb1
	mov	r5,a		;set up interval between DCO's * 2, for use as divider table offset
	sel	rb0

	anl	p2,#0BFH	;P26 low to enable IC11 I/O decoder
	mov	r7,#002H
	mov	r6,#003H
	mov	a,@r1
	jf0	L0761
	anl	a,#0F8H
L0761:
	xrl	a,#018H
	movx	@r1,a
	jmp	L076A

L0766:
	mov	r6,#003H
L0768:
	mov	a,@r1
	movx	@r1,a		;this was updating the VCF cut bits in the 8255
L076A:
	inc	r1		;seems like they always just copy 50,51,52,54,55,56,58 in RAM to same addr in hw
	djnz	r6,L0768

	inc	r1
	djnz	r7,L0766

	mov	a,@r1		;copy RAM 58 to hw 58
	movx	@r1,a

	orl	p2,#040H	;P26 high to disable IC11 I/O decoder
	ret


	
L0775:				;reset jumps here
	orl	p2,#0FFH
	clr	a
	outl	p1,a
	mov	psw,a

	mov	r0,#07FH
L077C:				;write 0 to all 128 RAM bytes/registers
	mov	@r0,a
	djnz	r0,L077C

	mov	a,#080H
	anl	p2,#0BFH	;P26=0, enable IC11 I/O decoder
	mov	r0,#053H	;set all IC42 8255 pins to be outputs
	movx	@r0,a
	mov	r0,#057H	;set all IC28 8255 pins to be outputs
	movx	@r0,a
	mov	r0,#05BH	;set all IC22 8255 pins to be outputs
	movx	@r0,a

	mov	r2,#036H
	mov	r0,#023H
	mov	r7,#004H

L0792:				;init all four 8253 timers
	mov	r3,#000H
	mov	r6,#003H

L0796:				;init an 8253
	mov	a,r3		;timer select		
	rr	a		
	rr	a		;rotate it into the top two bits
	orl	a,r2		;write 0x36 plus timer select bits to each timer
	movx	@r0,a		;this selects mode 3, square wave rate generator
	inc	r3		;which divides by N and leaves output high for half of the period
	djnz	r6,L0796	;inner loop

	xch	a,r0
	add	a,#004H		;add 4 to r0 to move to next 8253
	xch	a,r0
	djnz	r7,L0792	;outer loop

	orl	p2,#0FFH	;disable IC11 I/O decoder

	mov	a,#0E8H		;point to "PS61" (startup message)
	call	L07D3		;displays 4 chars at pg7 addr in acc

	call	L0522
	mov	r0,#024H
	clr	a
	call	L0606

	mov	r0,#026H
	mov	@r0,#0CCH

	dec	r0
	mov	@r0,#000H

	call	L071E
	strt	t
	en	tcnti
	en	i
	mov	r0,#025H
	mov	r7,#000H
L07C1:
	mov	a,@r0		;read RAM address 0x25
	jb7	L07C6
	jmp	L07C1

L07C6:
	call	L02DA		;read both switch rows
	mov	r0,#025H
	mov	@r0,#000H	;clear RAM address 0x25
	djnz	r7,L07C1	;and loop

	mov	a,#024H		;set P12, P15 (program mode)
	outl	p1,a

	jmp	L001A		;jump to main loop



L07D3:				;displays 4 chars at pg7 addr in acc
	mov	r2,a		;save ptr to text in r2
	mov	r1,#05BH
	clr	a
	mov	@r1,a		;clear value LSdig in display buffer
	inc	r1
	mov	@r1,a		;clear value MSdig in display buffer

	mov	r7,#006H
L07DC:
	inc	r1
	mov	a,r2
	movp	a,@a		;read seg pattern
	mov	@r1,a		;write it to display
	inc	r2
	djnz	r7,L07DC
	ret

				;some messages:
;L07E4:				;displayed if tape is enabled
	.db	$79		;E
	.db	$73		;P
	.db	$77		;A
	.db	$07		;T

;L07E8:
	.db	$06		;1
	.db	$7D		;6
	.db	$6D		;S
	.db	$73		;P

;L07EC:
	.db	$79		;E
	.db	$1D		;v
	.db	$77		;A
	.db	$6D		;S

;L07F0:
	.db	$5E		;d
	.db	$77		;A
	.db	$5C		;o
	.db	$38		;L

;L07F4:
	.db	$6E		;Y
	.db	$71		;F
	.db	$50		;r
	.db	$1D		;v

:L07F8:
	.db	$00		
	.db	$50		;r
	.db	$50		;r
	.db	$79		;E

;L07FC:
	.db	$5E		;d
	.db	$5C		;o
	.db	$5C		;o
	.db	$3D		;G

.END
